Subject: bug#62493: xelatex won't render fonts correctly without full texlive

From: John Kehayias <[email-masked]>
Date: Wed, 29 Mar 2023 15:21:55 +0000

Hi Ricardo,

Note that I didn't get your replies as it was sent just to the debbugs
email (I always find it strange that the bug email alias doesn't send to
the submitter by default). This message from Simon was helpful for me,
at least via Emacs: https://issues.guix.gnu.org/59855#2 (perhaps you
already know or have some other method, but thought I'd mention it and
I'm open to more such tricks!)

Ricardo Wurmus <[email-masked]> writes:

> We seem to be missing the xetex package that provides files for font mapping:
>
> $ info tex-text.tec
> tlmgr.pl: cannot find package tex-text.tec, searching for other matches:
>
> Packages containing `tex-text.tec' in their title/description:
>
> Packages containing files matching `tex-text.tec':
> xepersian:
> 	texmf-dist/fonts/misc/xetex/fontmapping/xepersian/persian-tex-text.tec
> xetex:
> 	texmf-dist/fonts/misc/xetex/fontmapping/base/tex-text.tec
>

Ah, that's good to know, thanks for figuring that out.

> I was under the impression that we did have a xetex package, but I can’t
> find it now.

I also don't see any record of such a package. Trying

--8<---------------cut here---------------start------------->8---
guix shell subversion -- guix import texlive xetex
[...]
Exported revision 59745.
A    /tmp/guix-directory.cKaqWd/doc/xetex/base
A    /tmp/guix-directory.cKaqWd/doc/xetex/base/NEWS
A    /tmp/guix-directory.cKaqWd/doc/xetex/base/README
A    /tmp/guix-directory.cKaqWd/doc/xetex/base/XeTeX-notes.pdf
A    /tmp/guix-directory.cKaqWd/doc/xetex/base/XeTeX-notes.tex
Exported revision 59745.
A    /tmp/guix-directory.cKaqWd/fonts/misc/xetex/fontmapping/base
A    /tmp/guix-directory.cKaqWd/fonts/misc/xetex/fontmapping/base/qx-unicode.map
A    /tmp/guix-directory.cKaqWd/fonts/misc/xetex/fontmapping/base/qx-unicode.tec
A    /tmp/guix-directory.cKaqWd/fonts/misc/xetex/fontmapping/base/tex-text.map
A    /tmp/guix-directory.cKaqWd/fonts/misc/xetex/fontmapping/base/tex-text.tec
Exported revision 59745.
svn: E160013: File not found: revision 66702, path '/tags/texlive-2021.3/Master/texmf-dist/tcode'
command "svn" "export" "--non-interactive" "--trust-server-cert" "-r" "59745" "svn://www.tug.org/texlive/tags/texlive-2021.3/Master/texmf-dist/tcode/" "/tmp/guix-directory.cKaqWd/tcode/" failed with status 1
guix import: error: failed to download description for package 'xetex'
--8<---------------cut here---------------end--------------->8---

or with a -r as well:

--8<---------------cut here---------------start------------->8---
Exported revision 59745.
A    /tmp/guix-directory.XcAtR6/doc/xetex/base
A    /tmp/guix-directory.XcAtR6/doc/xetex/base/NEWS
A    /tmp/guix-directory.XcAtR6/doc/xetex/base/README
A    /tmp/guix-directory.XcAtR6/doc/xetex/base/XeTeX-notes.pdf
A    /tmp/guix-directory.XcAtR6/doc/xetex/base/XeTeX-notes.tex
Exported revision 59745.
A    /tmp/guix-directory.XcAtR6/fonts/misc/xetex/fontmapping/base
A    /tmp/guix-directory.XcAtR6/fonts/misc/xetex/fontmapping/base/qx-unicode.map
A    /tmp/guix-directory.XcAtR6/fonts/misc/xetex/fontmapping/base/qx-unicode.tec
A    /tmp/guix-directory.XcAtR6/fonts/misc/xetex/fontmapping/base/tex-text.map
A    /tmp/guix-directory.XcAtR6/fonts/misc/xetex/fontmapping/base/tex-text.tec
Exported revision 59745.
svn: E160013: File not found: revision 66702, path '/tags/texlive-2021.3/Master/texmf-dist/tcode'
command "svn" "export" "--non-interactive" "--trust-server-cert" "-r" "59745" "svn://www.tug.org/texlive/tags/texlive-2021.3/Master/texmf-dist/tcode/" "/tmp/guix-directory.XcAtR6/tcode/" failed with status 1
Backtrace:
           8 (primitive-load "/home/john/.config/guix/current/bin/gu…")
In guix/ui.scm:
   2300:7  7 (run-guix . _)
  2263:10  6 (run-guix-command _ . _)
In guix/scripts/import.scm:
    89:11  5 (guix-import . _)
In ice-9/boot-9.scm:
  1752:10  4 (with-exception-handler _ _ #:unwind? _ # _)
In guix/scripts/import/texlive.scm:
    92:38  3 (_)
In guix/import/utils.scm:
   638:27  2 (recursive-import _ #:repo->guix-package _ #:guix-name . #)
   630:33  1 (lookup-node "xetex" #f)
In ice-9/boot-9.scm:
  1685:16  0 (raise-exception _ #:continuable? _)

ice-9/boot-9.scm:1685:16: In procedure raise-exception:
Wrong number of values returned to continuation (expected 2)
--8<---------------cut here---------------end--------------->8---

I'm not up to with texlive packaging, any tips? Or perhaps someone we
can ask for input here?

Thanks!
John